# CraftPresence

## [v2.4.0](https://github.com/CDAGaming/CraftPresence-Wow-Edition/tree/v2.4.0) (2022-06-09)
[Full Changelog](https://github.com/CDAGaming/CraftPresence-Wow-Edition/compare/v2.3.0.1...v2.4.0) [Previous Releases](https://github.com/CDAGaming/CraftPresence-Wow-Edition/releases)

- [Refactor] Misc. Cleanups  
    - Adjusted the CYAN coloring in texts to a light blue instead (`69CCF0`)  
    - Minor cleanups  
- [Fix] Fixed a typo where the addon name is referenced twice in the intro msg  
- [Change] Residual Code Cleanups  
- [Change] Final refactors before full release  
    - Removed Internal Data from Locale files to prevent duplication and allow proper systems management  
      - A `internals` and `colors` field have been added in their place in `GlobalUtils` as well as a new `FormatColor` to automate formatting additional hex codes into a readable format (`colors` just has a few presupplied color codes).  
    - Added an if case to prevent issues of params being nil in `AssertFrameSize`. This method is also now documented as Internal Use only.  
    - Moved `GetLength`, `ContainsAt`, `StartsWith`, and `EndsWith` from `Utils` to `GlobalUtils`. This is mostly since these functions were already pretty generalized, so were moved to where the other generalized functions were.  
    - Converted most `CraftPresence` usages to `self` usages in `GlobalUtils`.  
    - Added an `extended\_version` result param  to `GetBuildInfo`. This will return `version (toc\_version)`, and is being used for a cleaner format for the minimum and maximum toc descriptions seen throughout the Config UI.  
    - Updated the Prefilled Cyan coloring from `c9fcff` to `7DF8FF` to be an overall brighter coloring.  
- [Change] More Locale Rewrites  
    - Beginning work on reducing Internal Usage in here.  
- [Fix] Ensure Default Settings are loaded on time  
- [Fix] Added failsafes for dynamic default values  
    - Bug was present in /cp create as well as `GenerateDynamicTable` from Beta 2  
- Merge branch 'next'  
- [Change] Hopefully fixed the extremally large changelogs  
- [Fix] Restore 2.x Client access to the Retail UI via the minimap button or cmd  
    - Ref: https://github.com/MOUZU/Blizzard-WoW-Interface/blob/master/2.4.3/FrameXML/UIOptionsFrame.lua#L173  
    - Added a fallback in `ShowConfig` for `InterfaceOptionsFrame\_OpenToFrame` allowing the minimap icon and command to open in the retail ui.  
    - Also cleaned up some documentation and added a `minTOC` limiter of `2.0.0` for the `enforceInterface` check to align with the prior commit.  
- [Change] Adjusted the `disabled` condition for `enforceInterface`  
    - Since the modern UI is unavailable on 1.12.1 and below, the option is now disabled for those versions.  
- [Change] Added `enforceInterface` option to toggle retail interface on legacy clients  
- [Change] Final round of compatibility fixes for 1.12.1 ConfigUI Support  
    - Also resolves issues in relation to other addons running alongside CraftPresence in 1.12.1 Wow, apologies to the legacy users who had...issues occur.  
- [Change] Tightened the limitations over UI Registration  
    - Clients below Cataclysm, on a non-rebased api, will now show the legacy UI by default (This originally was for clients less then the original TBC client, but the decision was made to remove the shim functions from GlobalUtils due to potential incompatibilities with other addons.  
    - Enabling `optionalMigrations` will allow the retail-like UI to be used on the original TBC client and above. Do note however that the TBC client is not able to open the new ui from the cmd or minimap icon, due to the function required being missing, although the retail ui can be accessed manually once the `optionalMigrations` option is enabled.  
      - This option will change closer to release, since atm this is a setting being used for two different things, so I intend to separate it.  
- [Change] More compatibility fixes for Ace3  
- [Fix] Fixed scrolling in `MultiLineEditBox` for 2.x+ Clients  
- [Change] Code Cleanups  
- [Change] Removing and then re-creating a default placeholder now properly works  
    - In which it'll resupply any detected default values from `ProfileInfo`, rather then just creating blank info.  
- [Change] `GetConfigComment` defaults can now be either setting or locale based  
    - By default, if you specify a `default\_value`, it will use that value for the `value\_default` section of `GetConfigComment`. All applicable usages have already migrated to this new parameter to allow more accurate default text.  
- [Refactor] Standardize LibStub calls into a now-public table  
    - Mostly just a rename, but allows for deeper debugging as well  
- [Refactor] Moved `copyTable` to `GlobalUtils`  
    - Also is now public as `CraftPresence:CopyTable` with documentation.  
- [Refactor] Moved `EncodeConfigData` to `RPCDispatch`  
- [Change] Remove outdated logic from `AssertRenderSettings`  
    - TOC logic had been replaced with `ShouldProcessData` awhile ago, I just forgot to remove this piece of code.  
- [Refactor] Added a `key` param to Info retrieval tables  
    - `GetBuildInfo`, `GetAddOnInfo`, `GetFlavorInfo`, `GetCompatibilityInfo`, and `GetExtraBuildInfo` now contain an `key` param. If specified, this will allow easier retrieval of an element in that table rather then `function\_name()["table\_element"]`  
- [Fix] Fix `GetLocale` functionality  
    - Forgot to replace this reference, my bad.  
- [Change] Adjusted Color Codes to be more recognizable as RGB  
- [Change] Added `current\_toc` to the minimum and maximum toc comments  
    - Further changes to ship soon...  
- [Change] Deprecation of the `CP\_GlobalUtils` namespace  
    - This brings all the addon functions under the `CraftPresence` namespace. As `CP\_GlobalUtils` was only made for internal functions, a migration layer will not be made for this, so those using it are encouraged to use the `CraftPresence` namespace in applicable functions.  
- [Change] Begin v2.4.0 Development  
    - This commit is an entire overhaul of the existing locale logic, in development since v2.2.0.  
    - This identifies as part one of this rewrite, in which the following changes have been made:  
      - Removed usage of `local L = CraftPresence.locale` as locale data is now initialized in `OnInitialize` and thus declaring it beforehand will no longer work. All usages have instead been replaced with `self.locale` or `CraftPresence.locale`.  
      - Moved around the TOC load order so that functions in Utils.lua are now available for Locale files. This effectively also deprecates the `CP\_GlobalUtils` namespace, since that namespace was only added for locales to use critical functions.  
      - To prevent issues in locale data lookup, the `locale` table is initialized as an empty table, so any lookups before AceLocale is initialize will result in empty data. This is better then experiencing a crash, when this addon is designed for plug-and-play.  
